-- md5
CREATE TYPE md5;
CREATE FUNCTION md5_in (cstring) RETURNS md5 LANGUAGE c AS 'sha', 'md5_in';
CREATE FUNCTION md5_out (md5) RETURNS cstring LANGUAGE c AS 'sha', 'md5_out';
CREATE TYPE md5 ( INPUT = md5_in, OUTPUT = md5_out, INTERNALLENGTH = 16);
CREATE FUNCTION md5_cmp(md5, md5) RETURNS int4 IMMUTABLE LANGUAGE c AS 'sha', 'md5_cmp';
CREATE FUNCTION md5_eq(md5, md5) RETURNS bool IMMUTABLE LANGUAGE c AS 'sha', 'md5_eq';
CREATE FUNCTION md5_ne(md5, md5) RETURNS bool IMMUTABLE LANGUAGE c AS 'sha', 'md5_ne';
CREATE FUNCTION md5_ge(md5, md5) RETURNS bool IMMUTABLE LANGUAGE c AS 'sha', 'md5_ge';
CREATE FUNCTION md5_gt(md5, md5) RETURNS bool IMMUTABLE LANGUAGE c AS 'sha', 'md5_gt';
CREATE FUNCTION md5_le(md5, md5) RETURNS bool IMMUTABLE LANGUAGE c AS 'sha', 'md5_le';
CREATE FUNCTION md5_lt(md5, md5) RETURNS bool IMMUTABLE LANGUAGE c AS 'sha', 'md5_lt';
CREATE FUNCTION md5_hash(md5) RETURNS int IMMUTABLE LANGUAGE c AS 'sha', 'md5_hash';

CREATE OPERATOR <> ( PROCEDURE = md5_ne,
	LEFTARG = md5, RIGHTARG = md5,
	NEGATOR = =, RESTRICT = neqsel);
CREATE OPERATOR > ( PROCEDURE = md5_gt,
	LEFTARG = md5, RIGHTARG = md5,
	COMMUTATOR = <, NEGATOR = <=);
CREATE OPERATOR < ( PROCEDURE = md5_lt,
	LEFTARG = md5, RIGHTARG = md5,
	COMMUTATOR = >, NEGATOR = >=);
CREATE OPERATOR >= ( PROCEDURE = md5_ge,
	LEFTARG = md5, RIGHTARG = md5,
	COMMUTATOR = <=, NEGATOR = <);
CREATE OPERATOR <= ( PROCEDURE = md5_le,
	LEFTARG = md5, RIGHTARG = md5,
	COMMUTATOR = >=, NEGATOR = >);
CREATE OPERATOR = ( PROCEDURE = md5_eq,
	LEFTARG = md5, RIGHTARG = md5,
	COMMUTATOR = =, NEGATOR = <>, RESTRICT = eqsel, HASHES, MERGES);

CREATE OPERATOR CLASS md5_ops DEFAULT FOR TYPE md5 USING btree AS
       OPERATOR 1 <, OPERATOR 2 <=, OPERATOR 3 =, OPERATOR 4 >=, OPERATOR 5 >,
       FUNCTION 1 md5_cmp(md5, md5);
CREATE OPERATOR CLASS md5_ops DEFAULT FOR TYPE md5 USING hash AS
       OPERATOR 1 =, FUNCTION 1 md5_hash(md5);

CREATE FUNCTION text(md5) RETURNS TEXT LANGUAGE C AS 'sha', 'md5_to_text';
CREATE CAST (md5 AS text) WITH FUNCTION text(md5) AS ASSIGNMENT;

CREATE FUNCTION md5t(text) RETURNS md5 LANGUAGE C AS 'sha', 'text_to_md5';
CREATE CAST (text AS md5) WITH FUNCTION md5t(text) AS ASSIGNMENT;

CREATE FUNCTION md5b(bytea) RETURNS md5 LANGUAGE C AS 'sha', 'bytea_to_md5';
CREATE CAST (bytea AS md5) WITH FUNCTION md5b(bytea) AS ASSIGNMENT;
CREATE FUNCTION bytea(md5) RETURNS bytea LANGUAGE C AS 'sha', 'md5_to_bytea';
CREATE CAST (md5 AS bytea) WITH FUNCTION bytea(md5) AS ASSIGNMENT;
